
#include "./headers/funcs.h"


//rot
double funcrot (double rod, double yu, double yud, double ro) {
	return -rod*yu - yud*ro;
}


//rotx
double funcrotx (double roxx,double yu, double yud, double rod, double yuxx, double ro) {
	return -roxx*yu - 2.*yud*rod - yuxx*ro;
}

//yut
double funcyut (double yu, double yud, double pex, double qux, double ro) {
	return -yu*yud - (pex+qux)/ro ;
}


//yutx
double funcyutx (double yud, double yu, double yuxx, double pexx, double quxx, double ro, double pex, double qux, double rod) {
	return - pow(yud,2.) - yu*yuxx - (pexx+quxx)/ro + (pex + qux)*rod/pow(ro,2) ;
}

//ent
double funcent (double yu, double end, double pe, double qu, double yud, double ro) {
	return - yu* end - (pe + qu)*yud / ro;
}

//entx
double funcentx (double yud, double end, double yu, double enxx, double pex, double qux, double ro, double pe, double qu, double yuxx,
				double rod)  {
	return -yud*end - yu*enxx - (pex + qux)*yud/ro - (pe + qu)*yuxx/ro + (pe + qu)*yud*rod/pow(ro,2.) ;
}




//pe
double funcpe(double ro, double en) {
	return (g - 1.)*ro*en;
}

//pex
double funcpex(double rod, double en, double ro, double end) {
	return (g - 1.)*(rod*en + ro*end);
}

//pexx
double funcpexx(double roxx, double en, double rod, double end, double ro, double enxx) {
	return (g - 1.)*(roxx*en + 2.*rod*end + ro*enxx);
}

//cs
double funccs (double en) {
	return sqrt(g*(g - 1.)*en);
}

//qu
double funcqu (double ro, double cs, double yud) {
	return -a *dx* ro * cs * yud  ;
}

//qux
double funcqux (double cs, double rod, double yud, double ro, double yuxx) {
	return  -a*dx*cs*(rod*yud + ro*yuxx) ;
}

//quxx
double funcquxx (double cs, double roxx, double yud, double rod, double yuxx, double ro, double yu3x) {
	return -a*dx*cs* (roxx*yud + 2.*rod*yuxx + ro*yu3x) ;
}










