
#include <iostream>
#include <fstream>
#include <math.h>
#include <string.h>

using namespace std;

//o logos twn thermoxwrhtikothtwn statheros gia ola ta peiramata
const double g=1.4;
const double TOL=10e-6;

double p;


//boh8htikes synarthseis - dhlwseis
double alpha (double ro); // to A sel. 119
double betta (double pe); // to B sel. 119
double ssp (double ro, double pe); //sound speed

//h f synarthsh gia tis 2 periptwseis / sel.119
double fshock (double ro, double pe);
double frare (double ro, double pe);
double ffunc (char type, double ro, double pe);

//h f' synarthsh gia tis 2 periptwseis / sel.125
double f_shock (double ro, double pe);
double f_rare (double ro, double pe);
double f_func (char type, double ro, double pe);

//synarthseis gia ton kathorismo tou p0 (prosegistikes times)
double initp (int type,double rol, double ror, double pel, double per, double ul, double ur);
double ptr (double rol, double ror, double pel, double per, double ul, double ur);
double ppv (double rol, double ror, double pel, double per, double ul, double ur);
double pts (double rol, double ror, double pel, double per, double ul, double ur);
double half (double pel, double per);

//synarthseis ypologismou tou ypoloipou ths plhrous lyshs
//to r* gia tis diafores periptwseis bl. par 4.4 sel. 133
double rostar (char type, double ro, double pe);


double int_e (double ro, double pe); // synarthsh ypologismou eswterikhs energeias

double mabs (double a);
double test (double meta, double prin); // elegxos ths anadromikhs diadikasias

int main () {
		
	//arxikes synthikes gia ola ta test
	
	double tarol[] = {1., 1., 1., 1., 5.99924};
	double taul[] = {.0, -2., .0, .0, 19.5975};
	double tapel[] =  {1., .4, 1000., .01, 460.894};
	double taror[] = {.125, 1., 1., 1., 5.99242};
	double taur[] = {.0, 2., .0, .0, -6.19633};
	double taper[] = {.1, .4, .01, 100., 46.0950};
	char tatypes[5][2] = {{'r','s'},{'r','r'},{'r','s'},{'s','r'},{'s','s'}}; 
	
	//o arithmos tou problhmatos
	int pr;

	//h methodos tou 1ou guess
	int guess1;
	
	cout << "eisagete ton arithmo tou problhmatos" << endl;
	cin >> pr ; 
	
	
	//arxikopoihsh tou run
	
	double rol= tarol[pr-1];
	double ul= taul[pr-1];
	double pel= tapel[pr-1];
	double ror= taror[pr-1];
	double ur= taur[pr-1];
	double per= taper[pr-1];
	
	char typel= tatypes[pr-1][0];
	char typer= tatypes[pr-1][1];
	

	cout << "\naristero kyma " << typel << " de3i kyma " << typer <<endl;
	cout << "rol="<<rol<<" ul="<<ul<<" pel="<<pel<<" ror="<<ror<<" ur="<<ur<<" per="<<per <<endl;
	
	cout << "\neisagete thn methodo tou 1ou guess" << endl;
	cout << "1:Ptr 2:Ppv 3:Pts 4:mean " <<endl;
	cin >> guess1;
	
	
	
	double newp = initp(guess1,rol,ror,pel,per,ul,ur);
	
	
	switch (guess1) {
		case 1:
			cout << "Ptr = " << newp << endl;
			break;
		case 2:
			cout << "Ppv = " << newp << endl;
			break;
		case 3:
			cout << "Pts = " << newp << endl;
			break;
		case 4:
			cout << "mean = " << newp << endl;
			break;
		default :
			cout << "lathos epilogh arxikou guess " ;
	}
	
	double calc; // krataei to apotelesma twn ypologismwn gia na mhn epanalambanotai
	double check; // krataei thn sxetikh metabolh (gia na mhn ypologizetai x2)
	
	int  count=0;
	
	do {
		p = newp;
		calc = p - (ffunc(typel,rol,pel)+ffunc(typer,ror,per)+ur-ul)/(f_func(typel,rol,pel)+f_func(typer,ror,per));
		
		newp = (calc<0)? TOL : calc;
		count++;
		
		check = test (newp,p);
		cout << "sthn " << count << "h epanalhpsh to apotelesma einai " << newp 
			<< "  me relative change " << check << endl ;
	} while (check> TOL);
	
	cout << "\nmeta apo " << count << " epanalhpseis, to apotelesma einai: " << endl << newp << endl << endl ;
	
	//h parakatw metathesh sthn timh ginetai giati stis synarthseis ypologismou ths plhrous lyshs
	//opou Pstar yparxei h metablhth p
	p = newp;
	
	double Ustar = 1./2.*(ul + ur) + 1./2.*(ffunc(typer,ror,per)-ffunc(typel,rol,pel));

	cout << "To plhres ths lyshs exei ws e3hs :" << endl;
	cout << "Pstar=" << p << "  Ustar=" << Ustar
		<<"  ROstarl=" << rostar(typel,rol,pel) << "  ROstarr=" << rostar(typer, ror, per) << endl;
	
	
	
	// ekkinhsh diadikasia sampling kai kataxwrhshs sto data.txt
	//
	
	ofstream record_p ("data_p.txt");
	ofstream record_r ("data_r.txt");
	ofstream record_u ("data_u.txt");
	ofstream record_e ("data_e.txt");
	
	double t ;
	double x, xmin=-1, xmax=1, xstep=.01;
	
	cout << " \n eisagete to xroniko diasthma gia probolh ";
	cin >> t;
	cout << "\n";
	
	
	double rec_p, rec_r, rec_u ;
	
	//ypologizontai ta endexomena shock speeds aristera kai de3ia
	//gia na mhn ypologizontai se kathe epanalhpsh meta
	double shock_sl = ul - ssp(rol,pel)*sqrt((g+1)/2./g*p/pel + (g-1)/2./g);
	double shock_sr = ur + ssp(ror,per)*sqrt((g+1)/2./g*p/per + (g-1)/2./g);
	
	//to idio kai gia ta head/tail twn endexomenwn rarefaction waves
	double a_st_l = ssp(rol,pel) * pow(p/pel,(g-1)/2./g); //a* sx. (4.54) sel. 134
	double a_st_r = ssp(ror,per) * pow(p/per,(g-1)/2./g); //a* sx. (4.61) sel. 136
	
	double S_hl = ul - ssp(rol,pel); // taxythtes head kai tail gia rarefaction aristera
	double S_tl = Ustar - a_st_l;    // (4.55) sel. 134
	
	double S_hr = ur + ssp(ror,per); // taxythtes head kai tail gia rarefaction de3ia
	double S_tr = Ustar + a_st_r;	 // (4.62) sel. 136
	
	
	for (x = xmin+xstep ; x < xmax ; x += xstep ) { // sampling
		
		if ( x/t < Ustar) { // ean eimaste aristera tou contact wave
			
			if (p > pel){ // ean einai shock aristera
				
				if (x/t < shock_sl) { // eimaste aristera tou shock kai ara L
					
					rec_p = pel;
					rec_r = rol;
					rec_u = ul;
					
				} // endif aristera tou shock (L)
				
				else if (x/t > shock_sl) { // eimaste de3ia tou shock kai ara star region
					
					rec_p = p;
					rec_r = rostar('s',rol,pel);
					rec_u = Ustar;
				} // endif de3ia tou shock (star)
				
				else cout << "warnign : pesame panw sto aristero shock";
				
			} // end if gia shock aristera
			
			else if (p < pel) { // ean einai rarefaction aristera
				
				if (x/t < S_hl) { // eimaste sthn perioxh L
					
					rec_p = pel;
					rec_r = rol;
					rec_u = ul;
										
				} //endif eimaste aristera
				
				else if ( x/t > S_hl  &&  x/t < S_tl ) { // entos tou aristerou rarefaction
					
					rec_p = pel * pow(2./(g+1) + (g-1)/(g+1)/ssp(rol,pel)*(ul - x/t) ,2.*g/(g-1));	//apo (4.56) sel. 135
					rec_r = rol * pow(2./(g+1) + (g-1)/(g+1)/ssp(rol,pel)*(ul - x/t) ,2./(g-1));
					rec_u = 2./(g+1)*(ssp(rol,pel) + (g-1)/2.*ul + x/t);
					
				} //endif mesa sto rarefaction (l)
				
				else if (x/t > S_tl) { //eimaste star region
					
					rec_p = p;
					rec_r = rostar('r',rol,pel);
					rec_u = Ustar;
										
				} // end if star region
				
				else cout << "warning : aristero rarefaction kai synepesan oi taxythtes me head h tail";
			} // end if rarefaction aristera
			
			else cout << "error : aristera bre8hke p=pel / contact ????" ;
			
		} // endif aristera
		
		
		
		else if ( x/t > Ustar) { // ean eimaste de3ia tou contact wave
			
			if (p > per) { // de3i shock
				if (shock_sr < x/t) { // eimaste sthn perioxh R -> lysh Wr
					
					rec_p = per;
					rec_r = ror;
					rec_u = ur;
					
				}
				
				else if (shock_sr > x/t) { //eimaste star region -> lysh W*
					
					rec_p = p;
					rec_r = rostar('s', ror, per);
					rec_u = Ustar;
					
				}
				
				else cout << " warning : pesame panw sto de3i shock ";
			} // end if de3i shock
			
			else if (p < per) { //de3i rarefaction
				
				if ( x/t >  S_hr) { // eimaste de3ia tou rarefacion head -> eimaste R
					
					rec_p = per;
					rec_r = ror;
					rec_u = ur;
					
				}
				
				else if ( x/t < S_hr && x/t > S_tr) { // eimaste entos tou de3iou rarefaction fan
					
					rec_p = per * pow(2./(g+1) - (g-1)/(g+1)/ssp(ror,per) * (ur - x/t),2.*g/(g-1)); // apo (4.63) sel. 136
					rec_r = ror * pow(2./(g+1) - (g-1)/(g+1)/ssp(ror,per) * (ur - x/t),2./(g-1));
					rec_u = 2./(g+1) * (-ssp (ror,per) + (g-1)/2.*ur + x/t);
					
				}
				
				else if (x/t < S_tr) { // eimaste aristera tou de3iou rarefaction tail -> eimaste star region
					
					rec_p = p;
					rec_r = rostar( 'r', ror, per );
					rec_u = Ustar;
					
				}
				
				else cout << "warning : pesame panw se head h tail  sto de3i rarefaction " ;
						
			} // end if de3i rarefaction
			
			else cout << "error : de3ia brethike p*=per / contact ??? ";
		} // endif de3ia
		
	
		
		else cout << "warning : kai twra pou pesame panw sto contact ti? ";
		
		
		record_p << x+1 << "\t" << rec_p << "\n" ;
		record_r << x+1 << "\t" << rec_r << "\n" ;
		record_u << x+1 << "\t" << rec_u << "\n" ;
		record_e << x+1 << "\t" << int_e (rec_r,rec_p) << "\n" ;
		
		
	} //end for gia thn prospelash tou x (sampling)
	
	
	record_p.close();
	record_r.close();
	record_u.close();
	record_e.close();
	
	return 0;
}


//------------------------
// boh8htikes synarthseis - periexomeno
//-----------------------

double alpha (double ro) {
	return 2./(g+1)/ro;
}

double betta (double pe){
	return (g-1)*pe/(g+1);
}

double ssp (double ro, double pe){
	return sqrt(g*pe/ro);
}

//--------------------------
// Oi f synarthseis - ylopoihsh
//--------------------------------

double fshock (double ro, double pe){
	double a = alpha (ro); //to A ston typo
	double b = betta (pe); // to B ston typo
	return (p-pe)*sqrt(a/(p+b));	
}

double frare (double ro, double pe) {
	double a = ssp (ro,pe);
	return 2.*a*(pow(p/pe,(g-1)/(2.*g))-1)/(g-1);
}

double ffunc (char type, double ro, double pe) {
	if (type=='s') {return fshock(ro,pe);}
	else if (type=='r') {return frare(ro,pe);}
	else{
		cout << "h ffunc exei lathos orisma type " << endl ;
		return 0.0;
		}	
}

//------------------------
// oi f' synarthseis - ylopoihsh
//------------------------
double f_shock (double ro, double pe) {
	double a=alpha(ro);
	double b= betta(pe);
	return sqrt(a/(b+p))*(1-(p-pe)/2./(b+p));
}

double f_rare (double ro, double pe) {
	double a = ssp(ro,pe);
	return 1./ro/a*pow(p/pe,-(g+1)/2./g);
}

double f_func (char type, double ro, double pe) {
	if (type=='s') { return f_shock (ro,pe);}
	else if (type=='r') {return f_rare (ro,pe);}
	else {
		cout << "h f_func exei lathos orisma type " <<endl;
		return 0.0;
	}
}

//------------------------------
// oi synarthseis kathorismou tou arxikou p
//--------------------------------
double initp (int type,double rol, double ror, double pel, double per, double ul, double ur) {
	
	switch (type) {
	case 1:
		return ptr(rol,ror,pel,per,ul,ur);
		break;
	case 2:
		return ppv(rol,ror,pel,per,ul,ur);
		break;
	case 3:
		return pts(rol,ror,pel,per,ul,ur);
		break;
	case 4:
		return half(pel,per);
		break;
	default :
		cout << "sfalma ston kathorismo tou p0" ;
		return 0;
	}
	
}


double ptr (double rol, double ror, double pel, double per, double ul, double ur){
	double al=ssp(rol,pel);
	double ar=ssp(ror,per);
	double par= (g-1)/2./g;
	
	return pow((al+ar-1./2.*(g-1)*(ur-ul))/(al/pow(pel,par)+ar/pow(per,par)),1./par);
}

double ppv (double rol, double ror, double pel, double per, double ul, double ur){
	double par = 1./2.*(pel+per)-1./8.*(ur-ul)*(rol+ror)*(ssp(rol,pel)+ssp(ror,per));
	
	return ((TOL>=par) ? TOL : par);
}


double pts (double rol, double ror, double pel, double per, double ul, double ur){
	
	double par = ppv(rol,ror,pel,per,ul,ur); // to p pou mpainei san parametros sto g (dhl. to ppv telika)
	double geel = sqrt(alpha(rol)/(par+betta(pel)));
	double geer = sqrt(alpha(ror)/(par+betta(per)));
			
	double sxesh = (geel*pel + geer*per -ur +ul)/(geel + geer);
	
	return ((TOL>=sxesh) ? TOL : sxesh);
}

double half (double pel, double per){
	return 1./2.*(pel+per);
}

//-------------------
//boh8htikes synarthseis
//-----------------------

double mabs (double a) {
	return ((a<0) ? (-a) : a);
}

double test (double meta, double prin) {
	return mabs(meta - prin)/(1./2.*(meta + prin));
}

//--------------------------
//to r-star gia thn plhrh lysh
//---------------------------
double rostar (char type, double ro, double pe) {
	switch (type) {
		case 's':
			return ro*(p/pe + (g-1)/(g+1))/((g-1)/(g+1)*p/pe +1);
			break;
		case 'r':
			return ro*pow(p/pe,1./g);
			break;
		default :
			cout << "\n\nfunction rostar: sfalma sthn metablhth type\n\n";
			return .0;
			break;
	}
}


double int_e (double ro, double pe) { // ypologismos eswterikhs energeias
	
	return  pe / (g-1) / ro;
}
